local mod = ...



-- Building Function: Export Pottery -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_FUNCTION_WORKPLACE",
	Id = "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_RESOURCE_POTTERY",
	Name = "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_RESOURCE_POTTERY_NAME",
	IsPrivate = false,
	WorkerCapacity = 1,
	RelatedJob = { 
		Job = "JOB_HARBORTRADE_DOCK", 
		Behavior = "BEHAVIOR_WORK"
	},
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_COMMAND", Quantity = 2 },
		{ Resource = "RESOURCE_POTTERY", Quantity = 20 },
	},
	ResourceListNeeded = {
		{ Resource = "RESOURCE_COMMAND", Quantity = 1 },
		{ Resource = "RESOURCE_POTTERY", Quantity = 20 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_IMPORT", Quantity = 1 },
	}
})



-- Building Function: Import Pottery -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_FUNCTION_WORKPLACE",
	Id = "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_RESOURCE_POTTERY",
	Name = "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_RESOURCE_POTTERY_NAME",
	IsPrivate = false,
	WorkerCapacity = 1,
	RelatedJob = { 
		Job = "JOB_HARBORTRADE_DOCK", 
		Behavior = "BEHAVIOR_WORK"
	},
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_IMPORT", Quantity = 2 },
	},
	ResourceListNeeded = {
		{ Resource = "RESOURCE_IMPORT", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_POTTERY", Quantity = 20 },
	}
})



-- Building Function List: Export Goods (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_FUNCTION_LIST_HARBORTRADE_EXPORT_GOODS",
	AssetFunctionList = {
		Action = "APPEND",
		"BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_RESOURCE_POTTERY",
	}
})



-- Building Function List: Import Goods (OVERRIDE) -------------------------------------------------------------------------------------
mod:override({
	Id = "BUILDING_FUNCTION_LIST_HARBORTRADE_IMPORT_GOODS",
	AssetFunctionList = {
		Action = "APPEND",
		"BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_RESOURCE_POTTERY",
	}
})