local mod = ...


-- Building Asset Processor
mod:registerAssetProcessor("models/HarborTrade1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Ship1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Ship2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Boat1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Boat2.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })
mod:registerAssetProcessor("models/Boat3.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Materials -------------------------------------------------------------------------------------
mod:registerAssetId("models/HarborTrade1.fbx/Materials/Material.Plank1", "MATERIAL_HARBORTRADE_PLANK1")
mod:registerAssetId("models/HarborTrade1.fbx/Materials/Material.Tile1", "MATERIAL_HARBORTRADE_TILE1")
mod:registerAssetId("models/HarborTrade1.fbx/Materials/Material.Wall1", "MATERIAL_HARBORTRADE_WALL1")

mod:registerAssetId("models/HarborTrade1.fbx/Materials/Material.Plank2", "MATERIAL_HARBORTRADE_PLANK2")
mod:registerAssetId("models/HarborTrade1.fbx/Materials/Material.Tile2", "MATERIAL_HARBORTRADE_TILE2")
mod:registerAssetId("models/HarborTrade1.fbx/Materials/Material.Wall2", "MATERIAL_HARBORTRADE_WALL2")



-- Prefab -----------------------------------------------------------------------------------------------------------
mod:registerAssetId("models/HarborTrade1.fbx/Prefab/HousePart", "PREFAB_HARBORTRADE_HOUSE")
mod:registerAssetId("models/Ship1.fbx/Prefab/ShipPart1", "PREFAB_HARBORTRADE_SHIP1")
mod:registerAssetId("models/Ship2.fbx/Prefab/ShipPart2", "PREFAB_HARBORTRADE_SHIP2")
mod:registerAssetId("models/HarborTrade1.fbx/Prefab/GangplankPart", "PREFAB_HARBORTRADE_GANGPLANK")

mod:registerAssetId("models/HarborTrade1.fbx/Prefab/HouseConstruction", "PREFAB_CONSTR_HARBORTRADE_HOUSE")
mod:registerAssetId("models/HarborTrade1.fbx/Prefab/WarehousePart1", "PREFAB_HARBORTRADE_WAREHOUSE1")
mod:registerAssetId("models/HarborTrade1.fbx/Prefab/Warehouse1Construction", "PREFAB_CONSTR_HARBORTRADE_WAREHOUSE1")
mod:registerAssetId("models/HarborTrade1.fbx/Prefab/WarehousePart2", "PREFAB_HARBORTRADE_WAREHOUSE2")
mod:registerAssetId("models/HarborTrade1.fbx/Prefab/WarehousePart3", "PREFAB_HARBORTRADE_WAREHOUSE3")

mod:registerAssetId("models/Boat1.fbx/Prefab/BoatPart1", "PREFAB_HARBORTRADE_BOAT1")
mod:registerAssetId("models/Boat2.fbx/Prefab/BoatPart2", "PREFAB_HARBORTRADE_BOAT2")
mod:registerAssetId("models/Boat3.fbx/Prefab/BoatPart3", "PREFAB_HARBORTRADE_BOAT3")



-- Grounding  -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/HousePart/Door.001", {DataType = "COMP_GROUNDED"})

mod:registerPrefabComponent("models/Ship1.fbx/Prefab/ShipPart1", {DataType = "COMP_GROUNDED", GroundToWater = true})
mod:registerPrefabComponent("models/Ship2.fbx/Prefab/ShipPart2", {DataType = "COMP_GROUNDED", GroundToWater = true})

-- mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/GangplankPart", {DataType = "COMP_GROUNDED", GroundToWater = true})

mod:registerPrefabComponent("models/Boat1.fbx/Prefab/BoatPart1", {DataType = "COMP_GROUNDED", GroundToWater = true})
mod:registerPrefabComponent("models/Boat2.fbx/Prefab/BoatPart2", {DataType = "COMP_GROUNDED", GroundToWater = true})
mod:registerPrefabComponent("models/Boat3.fbx/Prefab/BoatPart3", {DataType = "COMP_GROUNDED", GroundToWater = true})

mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/WarehousePart1/Attach_Minor.003", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/WarehousePart1/Attach_Minor.007", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/WarehousePart2/Attach_Minor.002", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/WarehousePart2/Attach_Minor.004", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/WarehousePart3/Attach_Minor.005", {DataType = "COMP_GROUNDED"})
mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/WarehousePart3/Attach_Minor.006", {DataType = "COMP_GROUNDED"})



-- Collider Platform -------------------------------------------------------------------------------------
mod:configurePrefabFlagList("models/Ship1.fbx/Prefab/ShipPart1", { "PLATFORM" })
mod:configurePrefabFlagList("models/Ship2.fbx/Prefab/ShipPart2", { "PLATFORM" })
mod:configurePrefabFlagList("models/HarborTrade1.fbx/Prefab/GangplankPart", { "PLATFORM" })
mod:configurePrefabFlagList("models/Boat1.fbx/Prefab/BoatPart1", { "PLATFORM" })
mod:configurePrefabFlagList("models/Boat2.fbx/Prefab/BoatPart2", { "PLATFORM" })
mod:configurePrefabFlagList("models/Boat3.fbx/Prefab/BoatPart3", { "PLATFORM" })



-- Attach Node Type -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/GangplankPart", { DataType = "COMP_BUILDING_PART", BuildingPartType = "DOOR" })



-- Smoke Emitter -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/HousePart/SmokeEmitter.001", {
	DataType = "COMP_PARTICLE_EMITTER",
	ParticleSystem = "PARTICLE_SYSTEM_HOUSING_SMOKE",
	IsPlaying = true,
	IsEmitting = true
})

mod:registerPrefabComponent("models/HarborTrade1.fbx/Prefab/HousePart/SmokeEmitter.001", {
	DataType = "COMP_PARTICLE_EMITTER_TOGGLE",
	Enabled = false
})



-- Building: Harbor Trading -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING", 
	Id = "BUILDING_HARBORTRADE",
	Name = "BUILDING_HARBORTRADE_NAME",
	Description = "BUILDING_HARBORTRADE_DESC",
	BuildingType = "MONUMENT",
    AssetCoreBuildingPart = "BUILDING_PART_MONUMENT_POLE",
	BuildingPartSetList = {
		{
			Name = "BUILDING_SET_HARBORTRADE1_NAME",
			BuildingPartList = { 
				"BUILDING_PART_HARBORTRADE_HOUSE",
				-- "BUILDING_PART_HARBORTRADE_POLE",
			}
		},
		{
			Name = "BUILDING_SET_HARBORTRADE5_NAME",
			BuildingPartList = { 
				"BUILDING_PART_HARBORTRADE_SHIP1",
				"BUILDING_PART_HARBORTRADE_SHIP2",
				"BUILDING_PART_HARBORTRADE_GANGPLANK",
				"BUILDING_PART_HARBORTRADE_BOAT2",
				"BUILDING_PART_HARBORTRADE_BOAT3",
				"BUILDING_PART_HARBORTRADE_BOAT1",
			}
		},
		{
			Name = "BUILDING_SET_HARBORTRADE2_NAME",
			BuildingPartList = { 
				"BUILDING_PART_HARBORTRADE_WAREHOUSE1",
				"BUILDING_PART_HARBORTRADE_WAREHOUSE2",
				"BUILDING_PART_HARBORTRADE_WAREHOUSE3",
			}
		},
		{
			Name = "BUILDING_SET_HARBORTRADE3_NAME",
			BuildingPartList = { 
				"BUILDING_PART_HARBORTRADE_WAREHOUSE4",
				"BUILDING_PART_HARBORTRADE_WAREHOUSE5",
				"BUILDING_PART_HARBORTRADE_WAREHOUSE6",
			}
		},
		{
			Name = "BUILDING_SET_HARBORTRADE4_NAME",
			BuildingPartList = { 
				"CRANE_PART",
				"CART_PART",
				"BARGE_PART",
				"CRANE_SMALL_PART",
				"CART_CANOPY_PART",
				"BARGE_CANOPY_PART",
				"BARRELS_PART",
				"BARREL_LARGE_PART",
				"CRATES_PART",
				"GRAIN_PART",
				"SPOOLS_PART",
				"HAY_PART",
				"LOGS_PART",
				"PLANKS_PART",
				"COAL_PART",
				"BRICKS_PART",
				"STONES_PART",
				"MIX1_PART",
				"MIX2_PART",
				"MIX3_PART",
				"MIX4_PART",
				"MIX5_PART",
				"MIX6_PART"
			}
		},
    },
	-- RequiredPartList = {
		-- { Category = "CORE", Min = 1, Max = 1 },
		-- { Category = "BUILDING_PART_TYPE_POLE", Min = 1, Max = 1 },
	-- },
	VillagerRequired = { Status = "CITIZEN", Quantity = 5 },
	IsEditable = true,
	MaterialSetList = {
		{
			SetName = "MATERIAL_SET_HARBORTRADE1_NAME",
			MaterialList = {
				"MATERIAL_HARBORTRADE_PLANK1",
				"MATERIAL_HARBORTRADE_TILE1",
				"MATERIAL_HARBORTRADE_WALL1",
			}
		},
		{
			SetName = "MATERIAL_SET_HARBORTRADE2_NAME",
			MaterialList = {
				"MATERIAL_HARBORTRADE_PLANK2",
				"MATERIAL_HARBORTRADE_TILE2",
				"MATERIAL_HARBORTRADE_WALL2",
			}
		},
	}
})



-- Building Part: Trading House -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_HOUSE",
	Name = "BUILDING_PART_HARBORTRADE_HOUSE_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_HOUSE_DESC", 
	Category = "CORE",
	-- IsMonumentCore = true, -- this causes it to not build if it is the only part being built
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_HOUSE"
	},
	ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_HOUSE",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {5, 7}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_HARBORTRADE_MERCHANT",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 100 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        RessourcesNeeded = {
            { Resource = "STONE", Quantity = 20 },
            { Resource = "WOOD", Quantity = 20 },
            { Resource = "PLANK", Quantity = 40 },
		}
	}
})



-- Building Part: Ship 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_SHIP1",
	Name = "BUILDING_PART_HARBORTRADE_SHIP1_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_SHIP1_DESC", 
	-- Category = "CORE",
	-- IsMonumentCore = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_SHIP1"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_SHIP1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {9, 22}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_HARBORTRADE_CREW",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 250 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
		-- }
	}
})




-- Building Part: Ship 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_SHIP2",
	Name = "BUILDING_PART_HARBORTRADE_SHIP2_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_SHIP2_DESC", 
	-- Category = "CORE",
	-- IsMonumentCore = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_SHIP2"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_SHIP1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {9, 22}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_HARBORTRADE_CREW",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 250 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
		-- }
	}
})



-- Building Part: Gangplank -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_GANGPLANK",
	Name = "BUILDING_PART_HARBORTRADE_GANGPLANK_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_GANGPLANK_DESC", 
	Category = "DOOR",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_GANGPLANK"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_SHIP1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {0.6, 5.5}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	Cost = {
        -- BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 250 } },
        -- UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 50 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
		-- }
	}
})



-- Building Part: Boat 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_BOAT1",
	Name = "BUILDING_PART_HARBORTRADE_BOAT1_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_BOAT1_DESC", 
	-- Category = "CORE",
	-- IsMonumentCore = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_BOAT1"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_SHIP1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6, 18}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	-- AssetBuildingFunction = "BUILDING_FUNCTION_HARBORTRADE_CREW",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 75 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 15 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
		-- }
	}
})



-- Building Part: Boat 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_BOAT2",
	Name = "BUILDING_PART_HARBORTRADE_BOAT2_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_BOAT2_DESC", 
	-- Category = "CORE",
	-- IsMonumentCore = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_BOAT2"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_SHIP1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {6, 18}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_HARBORTRADE_CREW_SMALL1",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 75 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 15 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
		-- }
	}
})



-- Building Part: Boat 3 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_BOAT3",
	Name = "BUILDING_PART_HARBORTRADE_BOAT3_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_BOAT3_DESC", 
	-- Category = "CORE",
	-- IsMonumentCore = true,
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_BOAT3"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_SHIP1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4, 13}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_HARBORTRADE_CREW_SMALL2",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 45 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 10 } },
        -- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 20 },
        --     { Resource = "WOOD", Quantity = 20 },
        --     { Resource = "PLANK", Quantity = 40 },
		-- }
	}
})



-- mod:registerEnumValue ("BUILDING_PART_TYPE", "BUILDING_PART_TYPE_POLE")

-- -- Building Part: Pole -------------------------------------------------------------------------------------
-- mod:register({
-- 	DataType = "BUILDING_PART",
-- 	Id = "BUILDING_PART_HARBORTRADE_POLE",
-- 	Name = "BUILDING_PART_HARBORTRADE_POLE_NAME", 
-- 	Description = "BUILDING_PART_HARBORTRADE_POLE_DESC", 
-- 	Category = "BUILDING_PART_TYPE_POLE",
-- 	ConstructorData = {
-- 		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
-- 		CoreObjectPrefab = "PREFAB_HARBORTRADE_POLE"
-- 	},
-- 	BuildingZone = { 
--         ZoneEntryList = {
--             { 
--                 Polygon = polygon.createRectangle( {0.5, 0.5}, {0, 0} ),
--                 Type = { DEFAULT = true, WATER_CONSTRAINT = true, GRASS_CLEAR = false } 
-- 			}, 
-- 		}
-- 	},
-- 	Cost = {
--         BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 5 } },
-- 	}
-- })



-- Building Part: Warehouse 1: Export Food -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_WAREHOUSE1",
	Name = "BUILDING_PART_HARBORTRADE_WAREHOUSE1_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_WAREHOUSE1_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_WAREHOUSE1"
	},
	ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_WAREHOUSE1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.6, 3.9}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_EXPORT_FOOD",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 5 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
		}
	}
})



-- Building Part: Warehouse 2: Export Goods -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_WAREHOUSE2",
	Name = "BUILDING_PART_HARBORTRADE_WAREHOUSE2_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_WAREHOUSE2_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_WAREHOUSE2"
	},
	ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_WAREHOUSE1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.6, 3.9}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_EXPORT_GOODS",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 5 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
		}
	}
})



-- Building Part: Warehouse 3: Export Materials -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_WAREHOUSE3",
	Name = "BUILDING_PART_HARBORTRADE_WAREHOUSE3_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_WAREHOUSE3_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_WAREHOUSE3"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_WAREHOUSE3",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.6, 3.9}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_EXPORT_MATERIALS",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 5 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 4 },
		}
	}
})



-- Building Part: Warehouse 4: Import Food -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_WAREHOUSE4",
	Name = "BUILDING_PART_HARBORTRADE_WAREHOUSE4_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_WAREHOUSE4_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_WAREHOUSE1"
	},
	ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_WAREHOUSE1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.6, 3.9}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_IMPORT_FOOD",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 5 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
		}
	}
})



-- Building Part: Warehouse 5: Import Goods -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_WAREHOUSE5",
	Name = "BUILDING_PART_HARBORTRADE_WAREHOUSE5_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_WAREHOUSE5_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_WAREHOUSE2"
	},
	ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_WAREHOUSE1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.6, 3.9}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_IMPORT_GOODS",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 5 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
		}
	}
})



-- Building Part: Warehouse 6: Import Materials -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_HARBORTRADE_WAREHOUSE6",
	Name = "BUILDING_PART_HARBORTRADE_WAREHOUSE6_NAME", 
	Description = "BUILDING_PART_HARBORTRADE_WAREHOUSE6_DESC", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_HARBORTRADE_WAREHOUSE3"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_HARBORTRADE_WAREHOUSE3",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.6, 3.9}, {0, 0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = true } 
			}, 
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_IMPORT_MATERIALS",
	Cost = {
        BuildRightTaxes = {	{ Resource = "GOLD_COINS", Quantity = 10 } },
        UpkeepCost = { { Resource = "GOLD_COINS", Quantity = 5 } },
        RessourcesNeeded = {
            { Resource = "WOOD", Quantity = 2 },
		}
	}
})




-- Resource Type  -------------------------------------------------------------------------------------
mod:registerEnumValue( "RESOURCE_TYPE", "RESOURCE_TYPE_TRADE" )



-- Resource: Command -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Command.png", "ICON_COMMAND")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_COMMAND",
	ResourceName = "RESOURCE_COMMAND_NAME",
	Icon = "ICON_COMMAND",
	ResourceTypeList = { "RESOURCE_TYPE_TRADE" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = false,
	OrderId = 0
})


-- Resource: Import -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Import.png", "ICON_IMPORT")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_IMPORT",
	ResourceName = "RESOURCE_IMPORT_NAME",
	Icon = "ICON_IMPORT",
	ResourceTypeList = { "RESOURCE_TYPE_TRADE" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = true,
	OrderId = 0
})



-- Resource: Export -------------------------------------------------------------------------------------
mod:registerAssetId("icons/Export.png", "ICON_EXPORT")

mod:register({
	DataType = "RESOURCE",
	Id = "RESOURCE_EXPORT",
	ResourceName = "RESOURCE_EXPORT_NAME",
	Icon = "ICON_EXPORT",
	ResourceTypeList = { "RESOURCE_TYPE_TRADE" },
	IsTradable = false,
    DisplayInInventory = false,
	DisplayInToolbar = true,
	OrderId = 0
})



-- Job: Merchant -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_HARBORTRADE_MERCHANT",
	JobName = "JOB_HARBORTRADE_MERCHANT_NAME",
	JobDescription = "JOB_HARBORTRADE_MERCHANT_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 60.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        -- FemaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_FRONT",
        -- },
        -- FemaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_BELT",
        -- },
        -- MaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_FRONT",
        -- },
        -- MaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_BELT",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_HARBORTRADE_MERCHANT"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_HARBORTRADE_MERCHANT"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_HARBORTRADE_MERCHANT"
    }
})

mod:override({
    Id = "CITIZEN",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_HARBORTRADE_MERCHANT"
    }
})



-- Job: Dock Worker -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_HARBORTRADE_DOCK",
	JobName = "JOB_HARBORTRADE_DOCK_NAME",
	JobDescription = "JOB_HARBORTRADE_DOCK_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 30.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        -- FemaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_FRONT",
        -- },
        -- FemaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_BELT",
        -- },
        -- MaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_FRONT",
        -- },
        -- MaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_BELT",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_HARBORTRADE_DOCK"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_HARBORTRADE_DOCK"
    }
})



-- Job: Ship's Crew -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_HARBORTRADE_CREW",
	JobName = "JOB_HARBORTRADE_CREW_NAME",
	JobDescription = "JOB_HARBORTRADE_CREW_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_WORK",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 300.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        -- FemaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_FRONT",
        -- },
        -- FemaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_FEMALE_BELT",
        -- },
        -- MaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_FRONT",
        -- },
        -- MaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_ACTOR_MALE_BELT",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_HARBORTRADE_CREW"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_HARBORTRADE_CREW"
    }
})



-- Building Function: Merchant -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_HARBORTRADE_MERCHANT",
	Name = "BUILDING_FUNCTION_HARBORTRADE_MERCHANT_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_HARBORTRADE_MERCHANT", 
        Behavior = "BEHAVIOR_WORK"
	},
	-- HasMaximumInstance = true,
	-- MaximumInstanceAllowed = 2,
	InputInventoryCapacity = {
	},
    ResourceListNeeded = {
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_COMMAND", Quantity = 1 },
	}
})



-- Building Function: Ship's Crew -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_HARBORTRADE_CREW",
	Name = "BUILDING_FUNCTION_HARBORTRADE_CREW_NAME",
	IsPrivate = false,
    WorkerCapacity = 3,
    RelatedJob = { 
        Job = "JOB_HARBORTRADE_CREW", 
        Behavior = "BEHAVIOR_WORK"
	},
	-- HasMaximumInstance = true,
	-- MaximumInstanceAllowed = 2,
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_COMMAND", Quantity = 10 },
		{ Resource = "RESOURCE_EXPORT", Quantity = 10 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_COMMAND", Quantity = 10 },
		{ Resource = "RESOURCE_EXPORT", Quantity = 10 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_IMPORT", Quantity = 10 },
	}
})



-- Building Function: Riverboat Crew 1 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_HARBORTRADE_CREW_SMALL1",
	Name = "BUILDING_FUNCTION_HARBORTRADE_CREW_SMALL1_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_HARBORTRADE_CREW", 
        Behavior = "BEHAVIOR_WORK"
	},
	-- HasMaximumInstance = true,
	-- MaximumInstanceAllowed = 2,
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_COMMAND", Quantity = 4 },
		{ Resource = "RESOURCE_EXPORT", Quantity = 4 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_COMMAND", Quantity = 4 },
		{ Resource = "RESOURCE_EXPORT", Quantity = 4 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_IMPORT", Quantity = 4 },
	}
})



-- Building Function: Riverboat Crew 2 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_WORKPLACE",
    Id = "BUILDING_FUNCTION_HARBORTRADE_CREW_SMALL2",
	Name = "BUILDING_FUNCTION_HARBORTRADE_CREW_SMALL2_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_HARBORTRADE_CREW", 
        Behavior = "BEHAVIOR_WORK"
	},
	-- HasMaximumInstance = true,
	-- MaximumInstanceAllowed = 2,
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_COMMAND", Quantity = 2 },
		{ Resource = "RESOURCE_EXPORT", Quantity = 2 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_COMMAND", Quantity = 2 },
		{ Resource = "RESOURCE_EXPORT", Quantity = 2 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_IMPORT", Quantity = 2 },
	}
})



-- Function: Import/Export -------------------------------------------------------------------------------------
function registerImportExport(_resource, _qty)

	-- Building Function: Export
	-- Convert this quantity to 1 trade credit
	mod:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		Id = "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_" .. _resource,
		Name = "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_" .. _resource .. "_NAME",
		IsPrivate = false,
		WorkerCapacity = 1,
		RelatedJob = { 
			Job = "JOB_HARBORTRADE_DOCK", 
			Behavior = "BEHAVIOR_WORK"
		},
		InputInventoryCapacity = {
			{ Resource = _resource, Quantity = _qty },
		},
		ResourceListNeeded = {
			{ Resource = _resource, Quantity = _qty },
		},
		ResourceProduced = {
			{ Resource = "RESOURCE_EXPORT", Quantity = 1 },
		}
	})

	-- Building Function: Import
	-- Convert 2 trade credits to this quantity
	mod:register({
		DataType = "BUILDING_FUNCTION_WORKPLACE",
		Id = "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_" .. _resource,
		Name = "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_" .. _resource .. "_NAME",
		IsPrivate = false,
		WorkerCapacity = 1,
		RelatedJob = { 
			Job = "JOB_HARBORTRADE_DOCK", 
			Behavior = "BEHAVIOR_WORK"
		},
		InputInventoryCapacity = {
			{ Resource = "RESOURCE_IMPORT", Quantity = 2 },
		},
		ResourceListNeeded = {
			{ Resource = "RESOURCE_IMPORT", Quantity = 1 },
		},
		ResourceProduced = {
			{ Resource = _resource, Quantity = _qty },
		}
	})


end



-- Setup -------------------------------------------------------------------------------------
registerImportExport("RESOURCE_FRUIT", 50)
registerImportExport("WOOD", 50)
registerImportExport("CANDLE_RESOURCE", 50)
registerImportExport("COAL", 25)
registerImportExport("RESOURCE_CIDER", 25)
registerImportExport("BEER", 20)
registerImportExport("CHEESE", 20)
registerImportExport("HONEY", 20)
registerImportExport("CLOTHES", 10)
registerImportExport("WINE", 10)
registerImportExport("FURNITURE_RESOURCE", 10)
registerImportExport("GEMS", 1)
registerImportExport("JEWELRY", 1)
registerImportExport("FLOUR", 100)
registerImportExport("STONE", 100)
registerImportExport("WHEAT", 50)
registerImportExport("WOOL", 50)
registerImportExport("PLANK", 35)
registerImportExport("POLISHED_STONE", 35)
registerImportExport("WOOLEN_CLOTH", 25)
registerImportExport("SPEAR", 20)
registerImportExport("GLASS", 10)
registerImportExport("TOOL", 10)
registerImportExport("SWORD", 5)
registerImportExport("GOLD_BARS", 1)
registerImportExport("BARREL", 10)
registerImportExport("IRON", 7)
registerImportExport("MARBLE", 10)



-- Building Function: Export Food ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_EXPORT_FOOD",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_HARBORTRADE_EXPORT_FOOD"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_HARBORTRADE_EXPORT_FOOD",
    AssetFunctionList = {
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_RESOURCE_FRUIT",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_CHEESE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_HONEY",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_RESOURCE_CIDER",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_BEER",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_WINE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_WHEAT",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_FLOUR",
    }
})



-- Building Function: Export Goods ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
	Id = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_EXPORT_GOODS",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_HARBORTRADE_EXPORT_GOODS"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_HARBORTRADE_EXPORT_GOODS",
    AssetFunctionList = {
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_POLISHED_STONE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_CANDLE_RESOURCE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_WOOLEN_CLOTH",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_CLOTHES",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_PLANK",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_FURNITURE_RESOURCE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_BARREL",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_GLASS",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_TOOL",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_SWORD",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_SPEAR",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_JEWELRY",
    }
})



-- Building Function: Export Materials ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_EXPORT_MATERIALS",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_HARBORTRADE_EXPORT_MATERIALS"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
	Id = "BUILDING_FUNCTION_LIST_HARBORTRADE_EXPORT_MATERIALS",
    AssetFunctionList = {
		"BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_WOOD",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_STONE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_WOOL",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_COAL",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_IRON",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_MARBLE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_GOLD_BARS",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_EXPORT_GEMS",
    }
})



-- Building Function: Import Food ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_IMPORT_FOOD",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_HARBORTRADE_IMPORT_FOOD"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_HARBORTRADE_IMPORT_FOOD",
    AssetFunctionList = {
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_RESOURCE_FRUIT",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_CHEESE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_HONEY",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_RESOURCE_CIDER",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_BEER",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_WINE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_WHEAT",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_FLOUR",
    }
})



-- Building Function: Import Goods ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
	Id = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_IMPORT_GOODS",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_HARBORTRADE_IMPORT_GOODS"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_HARBORTRADE_IMPORT_GOODS",
    AssetFunctionList = {
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_POLISHED_STONE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_CANDLE_RESOURCE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_WOOLEN_CLOTH",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_CLOTHES",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_PLANK",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_FURNITURE_RESOURCE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_BARREL",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_GLASS",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_TOOL",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_SWORD",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_SPEAR",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_JEWELRY",
    }
})



-- Building Function: Import Materials ASSIGNABLE -------------------------------------------------------------------------------------

mod:register({
    DataType = "BUILDING_FUNCTION_ASSIGNABLE",
    Id = "BUILDING_FUNCTION_ASSIGNABLE_HARBORTRADE_IMPORT_MATERIALS",
    AuthorizedFunctionList = "BUILDING_FUNCTION_LIST_HARBORTRADE_IMPORT_MATERIALS"
})

mod:register({
    DataType = "BUILDING_FUNCTION_LIST",
    Id = "BUILDING_FUNCTION_LIST_HARBORTRADE_IMPORT_MATERIALS",
    AssetFunctionList = {
		"BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_WOOD",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_STONE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_WOOL",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_COAL",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_IRON",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_MARBLE",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_GOLD_BARS",
        "BUILDING_FUNCTION_HARBORTRADE_DOCK_IMPORT_GEMS",
    }
})

